function pflag = plot_3species_biofilm(T,Y,xflux,mflux,nspecies,nmet,N,ns,zs)

% Plot concentration time profiles at stool-biofilm interface

figure(1)
subplot(5,5,1)
plot(T,Y(:,1))
ylabel('BT')

subplot(5,5,2)
plot(T,Y(:,2))
ylabel('FP')

subplot(5,5,3)
plot(T,Y(:,3))
ylabel('EC')

subplot(5,5,4)
plot(T,Y(:,4))
ylabel('Glucose')

subplot(5,5,5)
plot(T,Y(:,5))
ylabel('Cysteine')

subplot(5,5,6)
plot(T,Y(:,6))
ylabel('Isoleucine')

subplot(5,5,7)
plot(T,Y(:,7))
ylabel('Leucine')

subplot(5,5,8)
plot(T,Y(:,8))
ylabel('Methionine')

subplot(5,5,9)
plot(T,Y(:,9))
ylabel('Proline')

subplot(5,5,10)
plot(T,Y(:,10))
ylabel('Serine')

subplot(5,5,11)
plot(T,Y(:,11))
ylabel('Trytophan')

subplot(5,5,12)
plot(T,Y(:,12))
ylabel('Valine')

subplot(5,5,13)
plot(T,Y(:,13))
ylabel('Acetate')

subplot(5,5,14)
plot(T,Y(:,14))
ylabel('Butyrate')

subplot(5,5,15)
plot(T,Y(:,15))
ylabel('CO2')

subplot(5,5,16)
plot(T,Y(:,16))
ylabel('Ethanol')

subplot(5,5,17)
plot(T,Y(:,17))
ylabel('Formate')

subplot(5,5,18)
plot(T,Y(:,18))
ylabel('Lactate')

subplot(5,5,19)
plot(T,Y(:,19))
ylabel('Propionate')

subplot(5,5,20)
plot(T,Y(:,20))
ylabel('Succinate')

subplot(5,5,21)
plot(T,Y(:,21))
xlabel('Time [h]')
ylabel('Antiobiotic')

% Plot concentration time profiles in middle of biofilm

mz = round(N/2);

figure(2)
subplot(5,5,1)
plot(T,Y(:,ns*mz+1))
ylabel('BT')

subplot(5,5,2)
plot(T,Y(:,ns*mz+2))
ylabel('FP')

subplot(5,5,3)
plot(T,Y(:,ns*mz+3))
ylabel('EC')

subplot(5,5,4)
plot(T,Y(:,ns*mz+4))
ylabel('Glucose')

subplot(5,5,5)
plot(T,Y(:,ns*mz+5))
ylabel('Cysteine')

subplot(5,5,6)
plot(T,Y(:,ns*mz+6))
ylabel('Isoleucine')

subplot(5,5,7)
plot(T,Y(:,ns*mz+7))
ylabel('Leucine')

subplot(5,5,8)
plot(T,Y(:,ns*mz+8))
ylabel('Methionine')

subplot(5,5,9)
plot(T,Y(:,ns*mz+9))
ylabel('Proline')

subplot(5,5,10)
plot(T,Y(:,ns*mz+10))
ylabel('Serine')

subplot(5,5,11)
plot(T,Y(:,ns*mz+11))
ylabel('Trytophan')

subplot(5,5,12)
plot(T,Y(:,ns*mz+12))
ylabel('Valine')

subplot(5,5,13)
plot(T,Y(:,ns*mz+13))
ylabel('Acetate')

subplot(5,5,14)
plot(T,Y(:,ns*mz+14))
ylabel('Butyrate')

subplot(5,5,15)
plot(T,Y(:,ns*mz+15))
ylabel('CO2')

subplot(5,5,16)
plot(T,Y(:,ns*mz+16))
ylabel('Ethanol')

subplot(5,5,17)
plot(T,Y(:,ns*mz+17))
ylabel('Formate')

subplot(5,5,18)
plot(T,Y(:,ns*mz+18))
ylabel('Lactate')

subplot(5,5,19)
plot(T,Y(:,ns*mz+19))
ylabel('Propionate')

subplot(5,5,20)
plot(T,Y(:,ns*mz+20))
ylabel('Succinate')

subplot(5,5,21)
plot(T,Y(:,ns*mz+21))
xlabel('Time [h]')
ylabel('Antibiotic')

% Plot concentration time profiles at biofilm-tissue interface

figure(3)
subplot(5,5,1)
plot(T,Y(:,ns*N+1))
ylabel('BT')

subplot(5,5,2)
plot(T,Y(:,ns*N+2))
ylabel('FP')

subplot(5,5,3)
plot(T,Y(:,ns*N+3))
ylabel('EC')

subplot(5,5,4)
plot(T,Y(:,ns*N+4))
ylabel('Glucose')

subplot(5,5,5)
plot(T,Y(:,ns*N+5))
ylabel('Cysteine')

subplot(5,5,6)
plot(T,Y(:,ns*N+6))
ylabel('Isoleucine')

subplot(5,5,7)
plot(T,Y(:,ns*N+7))
ylabel('Leucine')

subplot(5,5,8)
plot(T,Y(:,ns*N+8))
ylabel('Methionine')

subplot(5,5,9)
plot(T,Y(:,ns*N+9))
ylabel('Proline')

subplot(5,5,10)
plot(T,Y(:,ns*N+10))
ylabel('Serine')

subplot(5,5,11)
plot(T,Y(:,ns*N+11))
ylabel('Trytophan')

subplot(5,5,12)
plot(T,Y(:,ns*N+12))
ylabel('Valine')

subplot(5,5,13)
plot(T,Y(:,ns*N+13))
ylabel('Acetate')

subplot(5,5,14)
plot(T,Y(:,ns*N+14))
ylabel('Butyrate')

subplot(5,5,15)
plot(T,Y(:,ns*N+15))
ylabel('CO2')

subplot(5,5,16)
plot(T,Y(:,ns*N+16))
ylabel('Ethanol')

subplot(5,5,17)
plot(T,Y(:,ns*N+17))
ylabel('Formate')

subplot(5,5,18)
plot(T,Y(:,ns*N+18))
ylabel('Lactate')

subplot(5,5,19)
plot(T,Y(:,ns*N+19))
ylabel('Propionate')

subplot(5,5,20)
plot(T,Y(:,ns*N+20))
ylabel('Succinate')

subplot(5,5,21)
plot(T,Y(:,ns*N+21))
xlabel('Time [h]')
ylabel('Antibiotic')

% Plot concentration spatial profiles at final time

for i=1:N+1
    zloc(i) = (i-1)*zs;
    s1bm(i) = Y(end,ns*(i-1)+1);
    s2bm(i) = Y(end,ns*(i-1)+2);
    s3bm(i) = Y(end,ns*(i-1)+3);
    tbm(i) = s1bm(i)+s2bm(i)+s3bm(i);
    glc(i) = Y(end,ns*(i-1)+4);
    cys(i) = Y(end,ns*(i-1)+5);
    isl(i) = Y(end,ns*(i-1)+6);
    leu(i) = Y(end,ns*(i-1)+7);
    met(i) = Y(end,ns*(i-1)+8);
    pro(i) = Y(end,ns*(i-1)+9);
    ser(i) = Y(end,ns*(i-1)+10);
    trp(i) = Y(end,ns*(i-1)+11);
    val(i) = Y(end,ns*(i-1)+12);
    ace(i) = Y(end,ns*(i-1)+13);
    but(i) = Y(end,ns*(i-1)+14);
    co2(i) = Y(end,ns*(i-1)+15);
    eth(i) = Y(end,ns*(i-1)+16);
    frm(i) = Y(end,ns*(i-1)+17);
    lac(i) = Y(end,ns*(i-1)+18);
    prp(i) = Y(end,ns*(i-1)+19);
    suc(i) = Y(end,ns*(i-1)+20);
    ant(i) = Y(end,ns*(i-1)+21);
end

figure(4)
subplot(5,5,1)
plot(zloc,s1bm)
ylabel('BT')

subplot(5,5,2)
plot(zloc,s2bm)
ylabel('FP')

subplot(5,5,3)
plot(zloc,s3bm)
ylabel('EC')

subplot(5,5,4)
plot(zloc,glc)
ylabel('Glucose')

subplot(5,5,5)
plot(zloc,cys)
ylabel('Cysteine')

subplot(5,5,6)
plot(zloc,isl)
ylabel('Isoleucine')

subplot(5,5,7)
plot(zloc,leu)
ylabel('Leucine')

subplot(5,5,8)
plot(zloc,met)
ylabel('Methionine')

subplot(5,5,9)
plot(zloc,pro)
ylabel('Proline')

subplot(5,5,10)
plot(zloc,ser)
ylabel('Serine')

subplot(5,5,11)
plot(zloc,trp)
ylabel('Trytophan')

subplot(5,5,12)
plot(zloc,val)
ylabel('Valine')

subplot(5,5,13)
plot(zloc,ace)
ylabel('Acetate')

subplot(5,5,14)
plot(zloc,but)
ylabel('Butyrate')

subplot(5,5,15)
plot(zloc,co2)
ylabel('CO2')

subplot(5,5,16)
plot(zloc,eth)
ylabel('Ethanol')

subplot(5,5,17)
plot(zloc,frm)
ylabel('Formate')

subplot(5,5,18)
plot(zloc,lac)
ylabel('Lactate')

subplot(5,5,19)
plot(zloc,prp)
ylabel('Propionate')

subplot(5,5,20)
plot(zloc,suc)
ylabel('Succinate')

subplot(5,5,21)
plot(zloc,ant)
xlabel('Location (micron)')
ylabel('Antibiotic')

subplot(5,5,22)
plot(zloc,tbm)
xlabel('Location (micron)')
ylabel('Biomass')

% Plot exchange rate profiles at stool-biofilm interface

figure(5)
subplot(4,5,1)
plot(T,xflux(1:nspecies:end,1),T,xflux(2:nspecies:end,1),T,xflux(3:nspecies:end,1))
ylabel('Growth')
legend('BT','FP','EC')

subplot(4,5,2)
plot(T,mflux(1:nspecies:end,1,1),T,mflux(2:nspecies:end,1,1),T,mflux(3:nspecies:end,1,1))
ylabel('Glucose')

subplot(4,5,3)
plot(T,mflux(1:nspecies:end,2,1),T,mflux(2:nspecies:end,2,1),T,mflux(3:nspecies:end,2,1))
ylabel('Cysteine')

subplot(4,5,4)
plot(T,mflux(1:nspecies:end,3,1),T,mflux(2:nspecies:end,3,1),T,mflux(3:nspecies:end,3,1))
ylabel('Isoleucine')

subplot(4,5,5)
plot(T,mflux(1:nspecies:end,4,1),T,mflux(2:nspecies:end,4,1),T,mflux(3:nspecies:end,4,1))
ylabel('Leucine')

subplot(4,5,6)
plot(T,mflux(1:nspecies:end,5,1),T,mflux(2:nspecies:end,5,1),T,mflux(3:nspecies:end,5,1))
ylabel('Methionine')

subplot(4,5,7)
plot(T,mflux(1:nspecies:end,6,1),T,mflux(2:nspecies:end,6,1),T,mflux(3:nspecies:end,6,1))
ylabel('Proline')

subplot(4,5,8)
plot(T,mflux(1:nspecies:end,7,1),T,mflux(2:nspecies:end,7,1),T,mflux(3:nspecies:end,7,1))
ylabel('Serine')

subplot(4,5,9)
plot(T,mflux(1:nspecies:end,8,1),T,mflux(2:nspecies:end,8,1),T,mflux(3:nspecies:end,8,1))
ylabel('Tryptophan')

subplot(4,5,10)
plot(T,mflux(1:nspecies:end,9,1),T,mflux(2:nspecies:end,9,1),T,mflux(3:nspecies:end,9,1))
ylabel('Valine')

subplot(4,5,11)
plot(T,mflux(1:nspecies:end,10,1),T,mflux(2:nspecies:end,10,1),T,mflux(3:nspecies:end,10,1))
ylabel('Acetate')

subplot(4,5,12)
plot(T,mflux(1:nspecies:end,11,1),T,mflux(2:nspecies:end,11,1),T,mflux(3:nspecies:end,11,1))
ylabel('Butyrate')

subplot(4,5,13)
plot(T,mflux(1:nspecies:end,12,1),T,mflux(2:nspecies:end,12,1),T,mflux(3:nspecies:end,12,1))
ylabel('CO2')

subplot(4,5,14)
plot(T,mflux(1:nspecies:end,13,1),T,mflux(2:nspecies:end,13,1),T,mflux(3:nspecies:end,13,1))
ylabel('Ethanol')

subplot(4,5,15)
plot(T,mflux(1:nspecies:end,14,1),T,mflux(2:nspecies:end,14,1),T,mflux(3:nspecies:end,14,1))
ylabel('Formate')

subplot(4,5,16)
plot(T,mflux(1:nspecies:end,15,1),T,mflux(2:nspecies:end,15,1),T,mflux(3:nspecies:end,15,1))
xlabel('Time [h]')
ylabel('Lactate')

subplot(4,5,17)
plot(T,mflux(1:nspecies:end,16,1),T,mflux(2:nspecies:end,16,1),T,mflux(3:nspecies:end,16,1))
xlabel('Time [h]')
ylabel('Propionate')

subplot(4,5,18)
plot(T,mflux(1:nspecies:end,17,1),T,mflux(2:nspecies:end,17,1),T,mflux(3:nspecies:end,17,1))
xlabel('Time [h]')
ylabel('Succinate')

% Plot exchange rate profiles at middle of biofilm

mz = round((N+1)/2);

figure(6)
subplot(4,5,1)
plot(T,xflux(1:nspecies:end,mz),T,xflux(2:nspecies:end,mz),T,xflux(3:nspecies:end,mz))
ylabel('Growth')
legend('BT','FP','EC')

subplot(4,5,2)
plot(T,mflux(1:nspecies:end,1,mz),T,mflux(2:nspecies:end,1,mz),T,mflux(3:nspecies:end,1,mz))
ylabel('Glucose')

subplot(4,5,3)
plot(T,mflux(1:nspecies:end,2,mz),T,mflux(2:nspecies:end,2,mz),T,mflux(3:nspecies:end,2,mz))
ylabel('Cysteine')

subplot(4,5,4)
plot(T,mflux(1:nspecies:end,3,mz),T,mflux(2:nspecies:end,3,mz),T,mflux(3:nspecies:end,3,mz))
ylabel('Isoleucine')

subplot(4,5,5)
plot(T,mflux(1:nspecies:end,4,mz),T,mflux(2:nspecies:end,4,mz),T,mflux(3:nspecies:end,4,mz))
ylabel('Leucine')

subplot(4,5,6)
plot(T,mflux(1:nspecies:end,5,mz),T,mflux(2:nspecies:end,5,mz),T,mflux(3:nspecies:end,5,mz))
ylabel('Methionine')

subplot(4,5,7)
plot(T,mflux(1:nspecies:end,6,mz),T,mflux(2:nspecies:end,6,mz),T,mflux(3:nspecies:end,6,mz))
ylabel('Proline')

subplot(4,5,8)
plot(T,mflux(1:nspecies:end,7,mz),T,mflux(2:nspecies:end,7,mz),T,mflux(3:nspecies:end,7,mz))
ylabel('Serine')

subplot(4,5,9)
plot(T,mflux(1:nspecies:end,8,mz),T,mflux(2:nspecies:end,8,mz),T,mflux(3:nspecies:end,8,mz))
ylabel('Tryptophan')

subplot(4,5,10)
plot(T,mflux(1:nspecies:end,9,mz),T,mflux(2:nspecies:end,9,mz),T,mflux(3:nspecies:end,9,mz))
ylabel('Valine')

subplot(4,5,11)
plot(T,mflux(1:nspecies:end,10,mz),T,mflux(2:nspecies:end,10,mz),T,mflux(3:nspecies:end,10,mz))
ylabel('Acetate')

subplot(4,5,12)
plot(T,mflux(1:nspecies:end,11,mz),T,mflux(2:nspecies:end,11,mz),T,mflux(3:nspecies:end,11,mz))
ylabel('Butyrate')

subplot(4,5,13)
plot(T,mflux(1:nspecies:end,12,mz),T,mflux(2:nspecies:end,12,mz),T,mflux(3:nspecies:end,12,mz))
ylabel('CO2')

subplot(4,5,14)
plot(T,mflux(1:nspecies:end,13,mz),T,mflux(2:nspecies:end,13,mz),T,mflux(3:nspecies:end,13,mz))
ylabel('Ethanol')

subplot(4,5,15)
plot(T,mflux(1:nspecies:end,14,mz),T,mflux(2:nspecies:end,14,mz),T,mflux(3:nspecies:end,14,mz))
ylabel('Formate')

subplot(4,5,16)
plot(T,mflux(1:nspecies:end,15,mz),T,mflux(2:nspecies:end,15,mz),T,mflux(3:nspecies:end,15,mz))
xlabel('Time [h]')
ylabel('Lactate')

subplot(4,5,17)
plot(T,mflux(1:nspecies:end,16,mz),T,mflux(2:nspecies:end,16,mz),T,mflux(3:nspecies:end,16,mz))
xlabel('Time [h]')
ylabel('Propionate')

subplot(4,5,18)
plot(T,mflux(1:nspecies:end,17,mz),T,mflux(2:nspecies:end,17,mz),T,mflux(3:nspecies:end,17,mz))
xlabel('Time [h]')
ylabel('Succinate')

% Plot exchange rate profiles at biofilm-colon interface

figure(7)
subplot(4,5,1)
plot(T,xflux(1:nspecies:end,end),T,xflux(2:nspecies:end,end),T,xflux(3:nspecies:end,end))
ylabel('Growth')
legend('BT','FP','EC')

subplot(4,5,2)
plot(T,mflux(1:nspecies:end,1,end),T,mflux(2:nspecies:end,1,end),T,mflux(3:nspecies:end,1,end))
ylabel('Glucose')

subplot(4,5,3)
plot(T,mflux(1:nspecies:end,2,end),T,mflux(2:nspecies:end,2,end),T,mflux(3:nspecies:end,2,end))
ylabel('Cysteine')

subplot(4,5,4)
plot(T,mflux(1:nspecies:end,3,end),T,mflux(2:nspecies:end,3,end),T,mflux(3:nspecies:end,3,end))
ylabel('Isoleucine')

subplot(4,5,5)
plot(T,mflux(1:nspecies:end,4,end),T,mflux(2:nspecies:end,4,end),T,mflux(3:nspecies:end,4,end))
ylabel('Leucine')

subplot(4,5,6)
plot(T,mflux(1:nspecies:end,5,end),T,mflux(2:nspecies:end,5,end),T,mflux(3:nspecies:end,5,end))
ylabel('Methionine')

subplot(4,5,7)
plot(T,mflux(1:nspecies:end,6,end),T,mflux(2:nspecies:end,6,end),T,mflux(3:nspecies:end,6,end))
ylabel('Proline')

subplot(4,5,8)
plot(T,mflux(1:nspecies:end,7,end),T,mflux(2:nspecies:end,7,end),T,mflux(3:nspecies:end,7,end))
ylabel('Serine')

subplot(4,5,9)
plot(T,mflux(1:nspecies:end,8,end),T,mflux(2:nspecies:end,8,end),T,mflux(3:nspecies:end,8,end))
ylabel('Tryptophan')

subplot(4,5,10)
plot(T,mflux(1:nspecies:end,9,end),T,mflux(2:nspecies:end,9,end),T,mflux(3:nspecies:end,9,end))
ylabel('Valine')

subplot(4,5,11)
plot(T,mflux(1:nspecies:end,10,end),T,mflux(2:nspecies:end,10,end),T,mflux(3:nspecies:end,10,end))
ylabel('Acetate')

subplot(4,5,12)
plot(T,mflux(1:nspecies:end,11,end),T,mflux(2:nspecies:end,11,end),T,mflux(3:nspecies:end,11,end))
ylabel('Butyrate')

subplot(4,5,13)
plot(T,mflux(1:nspecies:end,12,end),T,mflux(2:nspecies:end,12,end),T,mflux(3:nspecies:end,12,end))
ylabel('CO2')

subplot(4,5,14)
plot(T,mflux(1:nspecies:end,13,end),T,mflux(2:nspecies:end,13,end),T,mflux(3:nspecies:end,13,end))
ylabel('Ethanol')

subplot(4,5,15)
plot(T,mflux(1:nspecies:end,14,end),T,mflux(2:nspecies:end,14,end),T,mflux(3:nspecies:end,14,end))
ylabel('Formate')

subplot(4,5,16)
plot(T,mflux(1:nspecies:end,15,end),T,mflux(2:nspecies:end,15,end),T,mflux(3:nspecies:end,15,end))
xlabel('Time [h]')
ylabel('Lactate')

subplot(4,5,17)
plot(T,mflux(1:nspecies:end,16,end),T,mflux(2:nspecies:end,16,end),T,mflux(3:nspecies:end,16,end))
xlabel('Time [h]')
ylabel('Propionate')

subplot(4,5,18)
plot(T,mflux(1:nspecies:end,17,end),T,mflux(2:nspecies:end,17,end),T,mflux(3:nspecies:end,17,end))
xlabel('Time [h]')
ylabel('Succinate')

for i=1:N+1
    zloc(i) = (i-1)*zs;
    vs1bm(i) = xflux(end-2,i);
    vs2bm(i) = xflux(end-1,i);
    vs3bm(i) = xflux(end,i); 
end

vglc = squeeze(mflux(end-2:end,1,:));
vcys = squeeze(mflux(end-2:end,2,:));
visl = squeeze(mflux(end-2:end,3,:));
vleu = squeeze(mflux(end-2:end,4,:));
vmet = squeeze(mflux(end-2:end,5,:));
vpro = squeeze(mflux(end-2:end,6,:));
vser = squeeze(mflux(end-2:end,7,:));
vtrp = squeeze(mflux(end-2:end,8,:));
vval = squeeze(mflux(end-2:end,9,:));
vace = squeeze(mflux(end-2:end,10,:));
vbut = squeeze(mflux(end-2:end,11,:));
vco2 = squeeze(mflux(end-2:end,12,:));
veth = squeeze(mflux(end-2:end,13,:));
vfrm = squeeze(mflux(end-2:end,14,:));
vlac = squeeze(mflux(end-2:end,15,:));
vprp = squeeze(mflux(end-2:end,16,:));
vsuc = squeeze(mflux(end-2:end,17,:));

figure(8)

subplot(4,5,1)
plot(zloc,vs1bm,zloc,vs2bm,zloc,vs3bm)
ylabel('Growth')
legend('BT','FP','EC')

subplot(4,5,2)
plot(zloc,vglc)
ylabel('Glucose')

subplot(4,5,3)
plot(zloc,vcys)
ylabel('Cysteine')

subplot(4,5,4)
plot(zloc,visl)
ylabel('Isoleucine')

subplot(4,5,5)
plot(zloc,vleu)
ylabel('Leucine')

subplot(4,5,6)
plot(zloc,vmet)
ylabel('Methionine')

subplot(4,5,7)
plot(zloc,vpro)
ylabel('Proline')

subplot(4,5,8)
plot(zloc,vser)
ylabel('Serine')

subplot(4,5,9)
plot(zloc,vtrp)
ylabel('Tryptophan')

subplot(4,5,10)
plot(zloc,vval)
ylabel('Valine')

subplot(4,5,11)
plot(zloc,vace)
ylabel('Acetate')

subplot(4,5,12)
plot(zloc,vbut)
ylabel('Butyrate')

subplot(4,5,13)
plot(zloc,vco2)
ylabel('CO2')

subplot(4,5,14)
plot(zloc,veth)
ylabel('Ethanol')

subplot(4,5,15)
plot(zloc,vfrm)
ylabel('Formate')

subplot(4,5,16)
plot(zloc,vlac)
xlabel('Location (micron)')
ylabel('Lactate')

subplot(4,5,17)
plot(zloc,vprp)
xlabel('Location (micron)')
ylabel('Propionate')

subplot(4,5,18)
plot(zloc,vsuc)
xlabel('Location (micron)')
ylabel('Succinate')

% Metabolites: glucose, cysteine, isoleucine, leucine, methionine, proline,
%              serine, tryptophan, valine, acetate, butyrate, co2, ethanol,
%              formate, lactate, propionate, succinate

pflag = 1;

end